; Copyright 2021 Mark Woodmass

; This program is licensed under the GNU General Public License. See the
; file `COPYING' for details

                        org   33024

start                   proc

                        call  3435
                        ld    a,2
                        call  #1601
                        ld    de,plus3_test_text
                        call  print_string

                        di
                        ld    (_oldstack+1),sp

                        ld    bc,#7ffd
                        ld    hl,#c000
                        ld    de,#0717
      _set_bank_bytes   out   (c),e
                        ld    (hl),d
                        dec   e
                        dec   d
                        jp    p,_set_bank_bytes

                        ld    e,#17
                        ld    a,7
      _chk_bank_bytes   out   (c),e
                        cp    (hl)
                        jr    nz,_error_7ffd
                        dec   e
                        dec   a
                        jp    p,_chk_bank_bytes


                        ld    hl,ROM_bytes
                        ld    de,#0400
      _rom_page_check   ld    bc,#1ffd
                        ld    a,e
                        rla
                        and   4
                        out   (c),a       ; ROM high bit
                        ld    b,#7f
                        ld    a,e
                        rla
                        rla
                        rla
                        rla
                        and   16
                        out   (c),a       ; ROM low bit

                        ld    a,(12)
                        cp    (hl)
                        jr    nz,_error_ROM_page

                        inc   hl
                        inc   e
                        dec   d
                        jr    nz,_rom_page_check

                        ; copy code to bank 6 for 64K RAM test
                        ld    bc,#7ffd
                        ld    a,22
                        out   (c),a
                        ld    hl,start
                        ld    de,+(start-32768)+49152
                        ld    bc,end_code-start
                        ldir
                        ld    bc,#7ffd
                        ld    a,16
                        out   (c),a

                        ; test 64K RAM modes 0-3
                        ld    a,3
                        ex    af,af'

                        ld    ix,banks_0123
                        ld    bc,#1ffd
                        ld    e,0
      _test_64K_loop    ld    a,e
                        rla
                        and   6
                        or    1
                        out   (c),a

                        ld    d,0
                        ld    l,0
      _test_64K_banks   ld    a,d
                        rrca
                        rrca
                        ld    h,a

                        ld    a,(hl)
                        cp    (ix+0)
                        jr    nz,_error_1ffd_64K

                        inc   ix
      
                        inc   d
                        bit   2,d   ; d = 0-3
                        jr    z,_test_64K_banks

                        ex    af,af'
                        inc   a
                        ex    af,af'

                        inc   e
                        bit   2,e     ; e = 0-3
                        jr    z,_test_64K_loop


;-----------------------------------------------------
      _no_error         ld    a,7
                        jr    _halt

      _error_1ffd_64K   ex    af,af'
                        jr    _halt

      _error_7ffd       xor   a
                        jr    _halt

      _error_1ffd       ld    a,1
                        jr    _halt


      _error_ROM_page   ld    a,2
                        jr    _halt

      _halt             out   (254),a
                        halt


_oldstack               ld    sp,0
                        ei
                        ret
                        endp

print_string            proc
      _loop             ld    a,(de)
                        inc   de
                        cp    255
                        ret   z
                        rst   16
                        jr    _loop
                        endp

plus3_test_text         db    "Border:", 13
                        db    "White   = Passed", 13, 13

                        db    "Black   = 7FFD RAM page fail", 13
                        db    "Blue    = 1FFD RAM page fail", 13
                        db    "Red     = ROM page fail", 13

                        db    13, "64K config tests:", 13
                        db    "Magenta = 1FFD 0/1/2/3 RAM fail", 13
                        db    "Green   = 1FFD 4/5/6/7 RAM fail", 13
                        db    "Cyan    = 1FFD 4/5/6/3 RAM fail", 13
                        db    "Yellow  = 1FFD 4/7/6/3 RAM fail", 13
                        db    255

ROM_bytes               db    #45, #00, #33, #5F

banks_0123              db    0, 1, 2, 3
banks_4567              db    4, 5, 6, 7
banks_4563              db    4, 5, 6, 3
banks_4763              db    4, 7, 6, 3

end_code:               end   start


;ROM 0: (12) = #45
;ROM 1: (12) = #00
;ROM 2: (12) = #33
;ROM 3: (12) = #5F

